#include <cmath>
#include "Auxiliaries.h"
#include "Input_Common.h"

using namespace std;

double OL(double s, double a, double b, double c) {
	return -(128*(1 - s)*s*(1 + s)*(1 + pow(s,2))*log(f(0,t(s))))/(Pi*sqrt((2 - pow(s,4))*(2 - 2*pow(s,4) + pow(s,8))));
}

double CALap(double w, double sl, double c, double z) {
	return -((1024*(1 - sl)*sl*(1 + sl)*(1 + pow(sl,2))*(-8*pow(c,2)*pow(Pi,2)*pow(w,3)*pow(1 + pow(w,4),4)*pow(z,6)*pow(-1 + pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
        (-1 - 4*(-1 + pow(w,4))*pow(z,2) + 6*(-1 + pow(w,4))*pow(z,4) - 4*(-1 + pow(w,4))*pow(z,6) + (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
        sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)*
        (-67 + 3*pow(Pi,2) - 33*log(-16*pow(sl,4)*(-2 + pow(sl,4))*pow(-1 + pow(sl,4),4)*(2 - 2*pow(sl,4) + pow(sl,8))))*log(f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FA(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FA(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FB(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FB(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       (pow(c,2)*pow(Pi,3)*pow(-1 + sl,2)*pow(sl,2)*pow(1 + sl,2)*pow(1 + pow(sl,2),2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(w,3)*pow(1 + pow(w,4),4)*pow(-1 + z,3)*
          pow(z,6)*pow(1 + z,3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
          pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
          pow(1 + pow(c,2) + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
          sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
          pow(-1 + pow(c,2)*(-1 - 4*(-1 + pow(w,4))*pow(z,2) + 6*(-1 + pow(w,4))*pow(z,4) - 4*(-1 + pow(w,4))*pow(z,6) + (-1 + pow(w,4))*pow(z,8)),2)*(-808 + 33*pow(Pi,2) + 756*Zeta3))/3.))/
   (9.*c*pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(w,4),3)*z*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*
     (1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
     (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
     (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
     pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)));
}

double NFLap(double w, double sl, double c, double z) {
	return -((-4096*c*(1 - sl)*sl*(1 + sl)*(1 + pow(sl,2))*(pow(Pi,2)*(56 - 3*pow(Pi,2))*pow(-1 + sl,2)*pow(sl,2)*pow(1 + sl,2)*pow(1 + pow(sl,2),2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*
        pow(1 + pow(w,4),4)*pow(z,10)*pow(w - w*pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),6)*
        pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2) + 
       24*pow(Pi,2)*pow(1 + pow(w,4),4)*pow(z,10)*pow(w - w*pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),6)*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
        sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)*
        (5 + 3*log(-16*pow(sl,4)*(-2 + pow(sl,4))*pow(-1 + pow(sl,4),4)*(2 - 2*pow(sl,4) + pow(sl,8))))*log(f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FA(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FA(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FB(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FB(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl)))))/
   (27.*pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(w,4),3)*pow(z,5)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
     (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
     (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
     pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)));
}

double CFLap(double x, double s, double sl, double c) {
	return 8192*mexp*(1 - s)*s*(1 + s)*(1 - sl)*sl*(1 + sl)*pow(c,-1)*pow(Pi,-2)*(1 + pow(s,2))*(1 + pow(sl,2))*pow(x,-1)*
   (4*Pi*pow(c,2)*pow(1 - s,2)*pow(s,2)*pow(1 + s,2)*pow(log(f(y(x),tl(sl))*pow(f(0,tl(sl)),-1)*pow(1 + pow(x,mexp),n)),2)*pow(1 + pow(s,2),2)*pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-0.5) + 
     8*Pi*log(f(0,tl(sl)))*log(f(y(x),tl(sl))*pow(f(0,tl(sl)),-1))*pow(c,2)*pow(s,2)*pow(-1 + pow(s,4),2)*pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-0.5) + 
     log(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))*GAa(y(x),0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GAa(y(x),0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*
        GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))*GAb(y(x),0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GAb(y(x),0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*
        pow(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0),-1)*pow(GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0),-1)*pow(GAa(y(x),0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-1)*
        pow(GAa(y(x),0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0),-1)*pow(GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0),-1)*
        pow(GAb(y(x),0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GAb(y(x),0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-1))*pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),-0.5)*
      pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-0.5) - 2*log(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*GAa(0,y(x),t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*
        GAa(0,y(x),t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))*GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*GAb(0,y(x),t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*
        GAb(0,y(x),t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))*GB(0,y(x),t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*GB(0,y(x),t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))*GB(y(x),0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*
        GB(y(x),0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))*pow(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-1)*
        pow(GAa(0,y(x),t(s),Tk1(t(s),0,tl(sl)),tl(sl),0),-1)*pow(GAa(0,y(x),t(s),Tk2(t(s),0,tl(sl)),tl(sl),0),-1)*pow(GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-1)*
        pow(GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GAb(0,y(x),t(s),Tk1(t(s),0,tl(sl)),tl(sl),0),-1)*pow(GAb(0,y(x),t(s),Tk2(t(s),0,tl(sl)),tl(sl),0),-1)*
        pow(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0),2)*pow(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-2)*pow(GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0),2)*
        pow(GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-2)*pow(GB(0,y(x),t(s),Tk1(t(s),0,tl(sl)),tl(sl),0),-1)*pow(GB(0,y(x),t(s),Tk2(t(s),0,tl(sl)),tl(sl),0),-1)*
        pow(GB(y(x),0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0),-1)*pow(GB(y(x),0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0),-1))*pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),-0.5)*
      pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-0.5) - 8*log(f(0,t(s)))*log(f(y(x),tl(sl))*pow(f(0,tl(sl)),-1))*pow(c,2)*pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),-0.5)*
      pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-0.5));
}

double CFCheckLap(double x, double s, double sl, double c) {
	return 512*(1 - s)*s*(1 + s)*(1 - sl)*sl*(1 + sl)*pow(c,-1)*pow(Pi,-2)*(1 + pow(s,2))*(1 + pow(sl,2))*pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),-0.5)*
   (log(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*
       pow(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-1)*
       pow(GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0),2)*pow(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-2)*
       pow(GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0),2)*pow(GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-2)) - 4*log(f(0,t(s)))*log(f(0,tl(sl)))*pow(c,2) + 
     4*Pi*pow(c,2)*pow(s,2)*pow(log(f(0,tl(sl))),2)*pow(1 - pow(s,4),2)*pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),0.5))*pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-0.5);
}

double CFVanishLap(double qx, double s, double sl, double c) {
	return 24576*(1 - s)*s*(1 + s)*(1 - sl)*sl*(1 + sl)*pow(c,-1)*pow(n,-1)*pow(Pi,-2)*pow(1 - qx,2)*(1 + pow(s,2))*(1 + pow(sl,2))*
    (-4*Pi*log(16*(2 - pow(sl,4))*pow(sl,4)*(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 - pow(sl,4),4))*pow(c,2)*pow(1 - s,2)*pow(s,2)*pow(1 + s,2)*pow(log(f(0,tl(sl))),2)*pow(1 + pow(s,2),2) + 
      8*Pi*pow(c,2)*pow(s,2)*pow(log(f(0,tl(sl))),3)*pow(1 - pow(s,4),2) + log(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))*
         GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))*pow(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0),-1)*pow(GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0),-1)*
         pow(GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0),-1)*pow(GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0),-1)*pow(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0),-2)*
         pow(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),2)*pow(GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0),-2)*pow(GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),2))*
       log(256*pow(c,4)*pow(1 - s,4)*(2 - pow(s,4))*pow(s,4)*(2 - 2*pow(s,4) + pow(s,8))*pow(1 + s,4)*pow(1 - sl,4)*(2 - pow(sl,4))*pow(sl,4)*(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + sl,4)*
         pow(1 + pow(c,2),-4)*pow(1 + pow(s,2),4)*pow(1 + pow(sl,2),4))*pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),-0.5) - 
      8*log(f(0,t(s)))*log(f(0,tl(sl)))*log((f(0,tl(sl))*pow(sl,-4)*pow(1 - pow(sl,4),-4)*pow(2 - pow(sl,4),-1)*pow(2 - 2*pow(sl,4) + pow(sl,8),-1))/16.)*pow(c,2)*
       pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),-0.5) + 2*(pow(log(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)),2) - pow(log(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))),2) + 
         pow(log(GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)),2) - pow(log(GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))),2) + pow(log(GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)),2) - 
         pow(log(GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))),2) + pow(log(GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)),2) - pow(log(GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))),2) + 
         2*pow(log(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)),2) - 2*pow(log(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))),2) + 2*pow(log(GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)),2) - 
         2*pow(log(GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))),2))*pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),-0.5))*pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-0.5) - 
   49152*(1 - s)*s*(1 + s)*(1 - sl)*sl*(1 + sl)*log(GAa(0,0,t(s),Tkcm(tl(sl),t(s),0),tl(sl),b(c))*GAa(0,0,t(s),Tkcp(tl(sl),t(s),0),tl(sl),b(c))*GAb(0,0,t(s),Tkcm(tl(sl),t(s),0),tl(sl),b(c))*
      GAb(0,0,t(s),Tkcp(tl(sl),t(s),0),tl(sl),b(c))*pow(GAa(0,0,t(s),Tkcm(tl(sl),t(s),Rx(qx)),tl(sl),b(c)),-1)*pow(GAa(0,0,t(s),Tkcp(tl(sl),t(s),Rx(qx)),tl(sl),b(c)),-1)*
      pow(GAb(0,0,t(s),Tkcm(tl(sl),t(s),Rx(qx)),tl(sl),b(c)),-1)*pow(GAb(0,0,t(s),Tkcp(tl(sl),t(s),Rx(qx)),tl(sl),b(c)),-1)*pow(GB(0,0,t(s),Tkcm(tl(sl),t(s),0),tl(sl),b(c)),2)*
      pow(GB(0,0,t(s),Tkcm(tl(sl),t(s),Rx(qx)),tl(sl),b(c)),-2)*pow(GB(0,0,t(s),Tkcp(tl(sl),t(s),0),tl(sl),b(c)),2)*pow(GB(0,0,t(s),Tkcp(tl(sl),t(s),Rx(qx)),tl(sl),b(c)),-2))*pow(c,-1)*pow(n,-1)*
    pow(Pi,-2)*pow(1 - qx,0.5)*pow(qx,-1)*(1 + pow(s,2))*(1 + pow(sl,2))*pow(3 - 3*qx + pow(qx,2),-1)*pow((1 + 3*qx - 3*pow(qx,2) + pow(qx,3))*(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12)),-0.5)*
    pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-0.5);
}


double CAMom(double w, double sl, double c, double z) {
	return -((1024*(1 - sl)*sl*(1 + sl)*(1 + pow(sl,2))*(-8*pow(c,2)*pow(Pi,2)*pow(w,3)*pow(1 + pow(w,4),4)*pow(z,6)*pow(-1 + pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
        (-1 - 4*(-1 + pow(w,4))*pow(z,2) + 6*(-1 + pow(w,4))*pow(z,4) - 4*(-1 + pow(w,4))*pow(z,6) + (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
        sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)*
        (-67 + 3*pow(Pi,2) - 33*log(-16*pow(sl,4)*(-2 + pow(sl,4))*pow(-1 + pow(sl,4),4)*(2 - 2*pow(sl,4) + pow(sl,8))))*log(f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FA(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FA(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FB(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FB(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       (pow(c,2)*pow(Pi,3)*pow(-1 + sl,2)*pow(sl,2)*pow(1 + sl,2)*pow(1 + pow(sl,2),2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(w,3)*pow(1 + pow(w,4),4)*pow(-1 + z,3)*
          pow(z,6)*pow(1 + z,3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
          pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
          pow(1 + pow(c,2) + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
          sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
          pow(-1 + pow(c,2)*(-1 - 4*(-1 + pow(w,4))*pow(z,2) + 6*(-1 + pow(w,4))*pow(z,4) - 4*(-1 + pow(w,4))*pow(z,6) + (-1 + pow(w,4))*pow(z,8)),2)*(-808 + 33*pow(Pi,2) + 756*Zeta3))/3.))/
   (9.*c*pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(w,4),3)*z*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*
     (1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
     (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
     (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
     pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)));
}

double NFMom(double w, double sl, double c, double z) {
	return -((-4096*c*(1 - sl)*sl*(1 + sl)*(1 + pow(sl,2))*(pow(Pi,2)*(56 - 3*pow(Pi,2))*pow(-1 + sl,2)*pow(sl,2)*pow(1 + sl,2)*pow(1 + pow(sl,2),2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*
        pow(1 + pow(w,4),4)*pow(z,10)*pow(w - w*pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),6)*
        pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2) + 
       24*pow(Pi,2)*pow(1 + pow(w,4),4)*pow(z,10)*pow(w - w*pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),6)*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
        sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)*
        (5 + 3*log(-16*pow(sl,4)*(-2 + pow(sl,4))*pow(-1 + pow(sl,4),4)*(2 - 2*pow(sl,4) + pow(sl,8))))*log(f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FA(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FA(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FB(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FB(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl)))))/
   (27.*pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(w,4),3)*pow(z,5)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
     (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
     (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
     pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)));
}

double CFMom(double x, double s, double sl, double c) {
	return 8192*mexp*(1 - s)*s*(1 + s)*(1 - sl)*sl*(1 + sl)*pow(c,-1)*pow(Pi,-2)*(1 + pow(s,2))*(1 + pow(sl,2))*pow(x,-1)*pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),-1)*
   pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-1)*(-8*log(f(0,t(s)))*log(f(y(x),tl(sl))*pow(f(0,tl(sl)),-1))*pow(c,2)*
      pow((-4 + 6*pow(s,4) - 4*pow(s,8) + pow(s,12))*(-4 + 6*pow(sl,4) - 4*pow(sl,8) + pow(sl,12)),0.5) + 
     pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),0.5)*((-3*log(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*
              GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)) + 3*log(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))*GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*
              GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))) - 4*log(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)) + 
           4*log(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))) + 
           2*log(GAa(0,y(x),t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GAa(0,y(x),t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*GAb(0,y(x),t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GAb(0,y(x),t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*
              GB(0,y(x),t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GB(0,y(x),t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*GB(y(x),0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GB(y(x),0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)) - 
           2*log(GAa(0,y(x),t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*GAa(0,y(x),t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))*GAb(0,y(x),t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*
              GAb(0,y(x),t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))*GB(0,y(x),t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*GB(0,y(x),t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))*GB(y(x),0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))*
              GB(y(x),0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))) + log(GAa(y(x),0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GAa(y(x),0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*GAb(y(x),0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*
             GAb(y(x),0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*pow(GAa(y(x),0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GAa(y(x),0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-1)*
             pow(GAb(y(x),0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GAb(y(x),0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-1)))*pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),0.5) + 
        8*Pi*log(f(0,tl(sl)))*log(f(y(x),tl(sl))*pow(f(0,tl(sl)),-1))*pow(c,2)*pow(s,2)*pow(-1 + pow(s,4),2)*
         pow((-4 + 6*pow(s,4) - 4*pow(s,8) + pow(s,12))*(-4 + 6*pow(sl,4) - 4*pow(sl,8) + pow(sl,12)),0.5) + 
        4*Pi*pow(c,2)*pow(s,2)*pow(log(f(y(x),tl(sl))*pow(f(0,tl(sl)),-1)*pow(1 + pow(x,mexp),n)),2)*pow(-1 + pow(s,4),2)*
         pow((-4 + 6*pow(s,4) - 4*pow(s,8) + pow(s,12))*(-4 + 6*pow(sl,4) - 4*pow(sl,8) + pow(sl,12)),0.5)));
}

double CFCheckMom(double x, double s, double sl, double c) {
	return (512*(1 - s)*s*(1 + s)*(1 - sl)*sl*(1 + sl)*pow(c,-1)*pow(Pi,-2)*(1 + pow(s,2))*(1 + pow(sl,2))*pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),-0.5)*pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-0.5)*
     (3*log(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*
          pow(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-1)*
          pow(GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0),2)*pow(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-2)*
          pow(GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0),2)*pow(GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-2)) - 12*log(f(0,t(s)))*log(f(0,tl(sl)))*pow(c,2) + 
       12*Pi*pow(c,2)*pow(-1 + s,2)*pow(s,2)*pow(1 + s,2)*pow(log(f(0,tl(sl))),2)*pow(1 + pow(s,2),2)*pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),0.5) - 
       2*pow(c,2)*pow(Pi,4)*pow(-1 + s,2)*pow(s,2)*pow(1 + s,2)*pow(-1 + sl,2)*pow(sl,2)*pow(1 + sl,2)*pow(1 + pow(s,2),2)*pow(1 + pow(sl,2),2)*
        pow((-4 + 6*pow(s,4) - 4*pow(s,8) + pow(s,12))*(-4 + 6*pow(sl,4) - 4*pow(sl,8) + pow(sl,12)),0.5)))/3.;
}

double CFVanishMom(double qx, double s, double sl, double c) {
	return -49152*s*sl*log(GAa(0,0,t(s),Tkcm(tl(sl),t(s),0),tl(sl),b(c))*GAa(0,0,t(s),Tkcp(tl(sl),t(s),0),tl(sl),b(c))*GAb(0,0,t(s),Tkcm(tl(sl),t(s),0),tl(sl),b(c))*GAb(0,0,t(s),Tkcp(tl(sl),t(s),0),tl(sl),b(c))*
      pow(GAa(0,0,t(s),Tkcm(tl(sl),t(s),Rx(qx)),tl(sl),b(c)),-1)*pow(GAa(0,0,t(s),Tkcp(tl(sl),t(s),Rx(qx)),tl(sl),b(c)),-1)*pow(GAb(0,0,t(s),Tkcm(tl(sl),t(s),Rx(qx)),tl(sl),b(c)),-1)*
      pow(GAb(0,0,t(s),Tkcp(tl(sl),t(s),Rx(qx)),tl(sl),b(c)),-1)*pow(GB(0,0,t(s),Tkcm(tl(sl),t(s),0),tl(sl),b(c)),2)*pow(GB(0,0,t(s),Tkcm(tl(sl),t(s),Rx(qx)),tl(sl),b(c)),-2)*
      pow(GB(0,0,t(s),Tkcp(tl(sl),t(s),0),tl(sl),b(c)),2)*pow(GB(0,0,t(s),Tkcp(tl(sl),t(s),Rx(qx)),tl(sl),b(c)),-2))*pow(c,-1)*pow(n,-1)*pow(Pi,-2)*pow(1 - qx,0.5)*pow(qx,-1)*pow(-1 + s,-2)*pow(1 + s,-2)*
    pow(-1 + sl,-2)*pow(1 + sl,-2)*pow(3 - 3*qx + pow(qx,2),-1)*pow(1 + pow(s,2),-2)*pow(1 - pow(s,4),3)*pow(1 + pow(sl,2),-2)*pow(1 - pow(sl,4),3)*
    pow((1 + 3*qx - 3*pow(qx,2) + pow(qx,3))*(-4 + 6*pow(s,4) - 4*pow(s,8) + pow(s,12))*(-4 + 6*pow(sl,4) - 4*pow(sl,8) + pow(sl,12)),-0.5) + 
   32768*c*pow(n,-1)*pow(1 - qx,2)*pow(s,3)*pow(sl,3)*pow(1 - pow(s,4),3)*pow(1 - pow(sl,4),3)*
    (-2*Pi*log(f(0,t(s)))*pow(s,-2)*pow(1 - pow(s,4),-2)*pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),-0.5) - 
      6*log(f(0,t(s)))*log(f(0,tl(sl)))*log((f(0,tl(sl))*pow(sl,-4)*pow(1 - pow(sl,4),-4)*pow(2 - pow(sl,4),-1)*pow(2 - 2*pow(sl,4) + pow(sl,8),-1))/16.)*pow(Pi,-2)*pow(-1 + s,-2)*pow(s,-2)*pow(1 + s,-2)*
       pow(-1 + sl,-2)*pow(sl,-2)*pow(1 + sl,-2)*pow(1 + pow(s,2),-2)*pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),-0.5)*pow(1 + pow(sl,2),-2)*pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-0.5) - 
      (3*log(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)*GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)*
           pow(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-1)*
           pow(GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-1)*pow(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0),2)*pow(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c)),-2)*
           pow(GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0),2)*pow(GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c)),-2))*
         log(256*pow(c,4)*pow(1 - s,4)*(2 - pow(s,4))*pow(s,4)*(2 - 2*pow(s,4) + pow(s,8))*pow(1 + s,4)*pow(1 - sl,4)*(2 - pow(sl,4))*pow(sl,4)*(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + sl,4)*
           pow(1 + pow(c,2),-4)*pow(1 + pow(s,2),4)*pow(1 + pow(sl,2),4))*pow(c,-2)*pow(Pi,-2)*pow(-1 + s,-2)*pow(s,-2)*pow(1 + s,-2)*pow(-1 + sl,-2)*pow(sl,-2)*pow(1 + sl,-2)*pow(1 + pow(s,2),-2)*
         pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),-0.5)*pow(1 + pow(sl,2),-2)*pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-0.5))/4. + 
      (3*pow(c,-2)*pow(Pi,-2)*pow(-1 + s,-2)*pow(s,-2)*pow(1 + s,-2)*pow(-1 + sl,-2)*pow(sl,-2)*pow(1 + sl,-2)*
         (pow(log(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)),2) - pow(log(GAa(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))),2) + pow(log(GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)),2) - 
           pow(log(GAa(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))),2) + pow(log(GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)),2) - pow(log(GAb(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))),2) + 
           pow(log(GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)),2) - pow(log(GAb(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))),2) + 2*pow(log(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),0)),2) - 
           2*pow(log(GB(0,0,t(s),Tk1(t(s),0,tl(sl)),tl(sl),b(c))),2) + 2*pow(log(GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),0)),2) - 2*pow(log(GB(0,0,t(s),Tk2(t(s),0,tl(sl)),tl(sl),b(c))),2))*
         pow(1 + pow(s,2),-2)*pow(4 - 6*pow(s,4) + 4*pow(s,8) - pow(s,12),-0.5)*pow(1 + pow(sl,2),-2)*pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-0.5))/2. - 
      3*log(16*(2 - pow(sl,4))*pow(sl,4)*(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 - pow(sl,4),4))*pow(Pi,-1)*pow(sl,-2)*pow(log(f(0,tl(sl))),2)*pow(1 - pow(sl,4),-2)*
       pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-0.5) + 6*pow(Pi,-1)*pow(sl,-2)*pow(log(f(0,tl(sl))),3)*pow(1 - pow(sl,4),-2)*pow(4 - 6*pow(sl,4) + 4*pow(sl,8) - pow(sl,12),-0.5) - 12*Zeta3);
}
