/*This file is part of SoftSERVE.
 *
 *   SoftSERVE is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   SoftSERVE is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with SoftSERVE.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef FOURINT_H_
#define FOURINT_H_

double I4EM2kl(double xk, double xl, double s, double s6);
double I4EM1kl(double xk, double xl, double s, double s6);
double I4E0kl(double xk, double xl, double s, double s6);

double I4EM2kc(double c, double xk, double s, double s6);
double I4EM1kc(double c, double xk, double s, double s6);
double I4E0kc(double c, double xk, double s, double s6);

double I4EM2ks(double xk, double s, double s5, double s6);
double I4EM1ks(double xk, double s, double s5, double s6);
double I4E0ks(double xk, double s, double s5, double s6);

double I4EM2lc(double c, double xl, double s, double s6);
double I4EM1lc(double c, double xl, double s, double s6);
double I4E0lc(double c, double xl, double s, double s6);

double I4EM2ls(double xl, double s, double s5, double s6);
double I4EM1ls(double xl, double s, double s5, double s6);
double I4E0ls(double xl, double s, double s5, double s6);

double I4EM2cs(double c, double s, double s5, double s6);
double I4EM1cs(double c, double s, double s5, double s6);
double I4E0cs(double c, double s, double s5, double s6);

#endif /* FOURINT_H_ */
