#ifndef AUXILIARIES_H_
#define AUXILIARIES_H_

typedef double decimal;

#define EulerGamma 0.577215664901532860606512090082402431042159335939923598805767
#define Zeta3 1.20205690315959428539973816151144999076498629234049888179227
#define Pi 3.14159265358979323846264338327950288419716939937510582097494
#define Zeta5 1.0369277551433699263313654864570341680570809195019

const int digits=8;

const int ndim2=2;
const int ndim3=3;
const int ndim4=4;
const int ndim5=5;

const int ncompCA=17;
const int ncompNF=7;
const int ncomp1P=21;

double f(decimal y,decimal t);

decimal v(double w);
decimal tl(double s6);
decimal y(double x);
decimal t5(double s5);
decimal u(double z);
decimal b(double c);
decimal A(decimal u, decimal v);
decimal T(decimal u, decimal v);
decimal Tk1(decimal t, decimal t5, decimal tl);
decimal Tk2(decimal t, decimal t5, decimal tl);
decimal Ck1(decimal t, decimal t5, decimal tl);
decimal Ck2(decimal t, decimal t5, decimal tl);
decimal Cl(decimal tl);
decimal Ck(decimal tk);

double FA1(decimal v,decimal tl,decimal y,decimal t5,decimal u,decimal b);
double FA2(decimal v,decimal tl,decimal y,decimal t5,decimal u,decimal b);
double FB1(decimal v,decimal tl,decimal y,decimal t5,decimal u,decimal b);
double FB2(decimal v,decimal tl,decimal y,decimal t5,decimal u,decimal b);

double FA(decimal v,decimal tl,decimal y,decimal t5,decimal u,decimal b);
double FB(decimal v,decimal tl,decimal y,decimal t5,decimal u,decimal b);

double RegulA(decimal c,decimal z,decimal w);
double RegulB(decimal c,decimal z,decimal w);

int D2IntCA(const int *ndim, const double x[],
const int *ncomp, double F[], void *userdata);

int D3IntCA(const int *ndim, const double x[],
const int *ncomp, double F[], void *userdata);

int D3IntNF(const int *ndim, const double x[],
const int *ncomp, double F[], void *userdata);

int D4IntCA(const int *ndim, const double x[],
const int *ncomp, double F[], void *userdata);

int D4IntNF(const int *ndim, const double x[],
const int *ncomp, double F[], void *userdata);

int D5IntCA(const int *ndim, const double x[],
const int *ncomp, double F[], void *userdata);

int D5IntNF(const int *ndim, const double x[],
const int *ncomp, double F[], void *userdata);

int D2Int1P(const int *ndim, const double x[],
const int *ncomp, double F[], void *userdata);

extern const int seed;
extern const int flags;

extern const int maxpass2;
extern const int maxpass3;
extern const int maxpass4;
extern const int maxpass5;

extern const double border;
extern const double maxchisq;
extern const double mindev;

extern const double epsrel2;
extern const double epsabs2;
extern const double epsrel3;
extern const double epsabs3;
extern const double epsrel4;
extern const double epsabs4;
extern const double epsrel5;
extern const double epsabs5;

extern const long long int maxeval2;
extern const long long int maxeval3;
extern const long long int maxeval4;
extern const long long int maxeval5;

extern const int key12;
extern const int key22;
extern const int key32;
extern const int key13;
extern const int key23;
extern const int key33;
extern const int key14;
extern const int key24;
extern const int key34;
extern const int key15;
extern const int key25;
extern const int key35;

inline double ReturnDouble(decimal a) {
	return a;
}

#endif /* AUXILIARIES_H_ */
